#!/system/bin/sh
########################################
# /data/local/swipe-for-quarx/swipe-for-quarx.sh
# permissions root:root -rwxr-xr-x 0755
########################################
# Google Gesture Typing v1 2015-04-03
# Author: ooo @ android-hilfe.de
# Target devices: 
# Defy MB525/Defy Plus MB526
# Target ROM: 
# CM11 KitKat 4.4.4 New Life by Quarx @ xda
########################################

########################################
# open the partitions for writing
########################################
# save current states
local m_mount_bootstrap="ro"
local m_mount_root="ro"
local m_mount_system="ro"
local m_mount_data="ro"
if [ -w "/bootstrap" ]; then m_mount_bootstrap="rw"; fi
if [ -w "/" ]; then m_mount_root="rw"; fi
if [ -w "/system" ]; then m_mount_system="rw"; fi
if [ -w "/data" ]; then m_mount_data="rw"; fi
# set write state
mount -o remount,rw /bootstrap
mount -o remount,rw /
mount -o remount,rw /system
mount -o remount,rw /data

########################################
# ROM tweak: 
# replace the original keyboard library
# /system/lib/libjni_latinime.so
########################################
local m_base_dir="/data/local/swipe-for-quarx"
local m_shellscript="swipe-for-quarx.sh"
local m_source_dir="$m_base_dir/google-gesture-typing"
local m_source_dir_save="$m_base_dir/original.save"
local m_target_dir="/system/lib"
local m_file_name="libjni_latinime.so"
local m_userinit_d="/data/local/userinit.d"
local m_symlink="98-swipe-for-quarx"

if [ -d "$m_source_dir/$m_file_name" ] ; then

   if [ -e "$m_target_dir/$m_file_name" ] ; then

      if [ ! -e "$m_source_dir_save/$m_file_name" ] ; then
      
         mkdir -p "$m_source_dir_save"
         cp -p -P "$m_target_dir/$m_file_name" "$m_source_dir_save/$m_file_name"

         cp -p -P "$m_source_dir/$m_file_name" "$m_target_dir/$m_file_name"
         chown root:root "$m_target_dir/$m_file_name"
         chmod 644 "$m_target_dir/$m_file_name"

         mkdir -p "$m_userinit_d"
         chown root:root "$m_userinit_d"
         chmod 755 "$m_userinit_d"
         
         ln -s "$m_base_dir/$m_shellscript" "$m_userinit_d/$m_symlink"
         #chown -h root:root "$m_userinit_d/$m_symlink"
         chmod 777 "$m_userinit_d/$m_symlink"
      fi
   fi
fi

########################################
# reset the partitions to their initial state
########################################
mount -o remount,"$m_mount_data" /data
mount -o remount,"$m_mount_system" /system
mount -o remount,"$m_mount_root" /
mount -o remount,"$m_mopunt_bootstrap" /bootstrap

